//----------------------------------------------------------------
//
// OpenDCC
//
// Copyright (c) 2006 Kufer
//
// This source file is subject of the GNU general public license 2,
// that is available at the world-wide-web at
// http://www.gnu.org/licenses/gpl.txt
//
//-----------------------------------------------------------------
//
// file:      programmer.h
// author:    Wolfgang Kufer
// contact:   kufer@gmx.de
// history:   2006-04-13 V0.1 started
//            2006-12-04 V0.2 change to multitasking

// 2do:       not completed
//
//-----------------------------------------------------------------
//
// purpose:   lowcost central station for dcc
// content:   builds service mode

extern unsigned int prog_cv;             // aktuelle cv;
extern unsigned char prog_data;
  
extern unsigned char ps_bitpos;        // Bitpos bzw. lokaler Programmschritt 

extern unsigned char prog_result_size;

extern unsigned char prog_event;        // 0=no new event, 1=event

extern enum t_prog_result
  {
    PT_OKAY     = 0x00,     // Command completed, no errors
    PT_TIMEOUT  = 0xFF,     // Timeout
    PT_NOACK    = 0xFE,     // No acknowledge from decoder (but a write maybe was successful)
    PT_SHORT    = 0xFD,     // Short! (on the PT)
    PT_NODEC    = 0xFC,     // No decoder detected
    PT_ERR      = 0xFB,     // Generic Error
    PT_BITERR   = 0xFA,     // Error during DCC direct bit mode operation
    PT_PAGERR   = 0xF9,     // No acknowledge to paged operation (paged r/w not supported?)
    PT_SELX     = 0xF8,     // Error during Selectrix read
    PT_DCCQD_Y  = 0xF7,     // XPT_DCCQD: Ok (direct bit read mode is (probably) supported)
    PT_DCCQD_N  = 0xF6,     // XPT_DCCQD: Not Ok (direct bit read mode is (probably) not supported)
    PT_TERM     = 0xF4,     // Task terminated (see XPT_Term cmd)
    PT_NOTASK   = 0xF3,     // No task to terminate (see XPT_Term cmd)
    PT_NOTERM   = 0xF2,     // Cannot terminate task (see XPT_Term cmd)
  } prog_result;


void init_programmer(void);
void run_programmer(void);
void enter_progmode(void);
void leave_progmode(void);  // switch to run_off

unsigned char programmer_busy(void);

unsigned char my_XPT_DCCRR (unsigned int cv);                                           // ec, registered
unsigned char my_XPT_DCCWR (unsigned int cv, unsigned char data);                       // ed, registered
unsigned char my_XPT_DCCRP (unsigned int cv);                                           // ee, paged
unsigned char my_XPT_DCCWP (unsigned int cv, unsigned char data);                       // ef, paged
unsigned char my_XPT_DCCRD (unsigned int cv);                                           // f0, direct
unsigned char my_XPT_DCCWD (unsigned int cv, unsigned char data);                       // f1, direct
unsigned char my_XPT_DCCRB (unsigned int cv);                                           // f2, bit
unsigned char my_XPT_DCCWB (unsigned int cv, unsigned char bitpos, unsigned char data); // f3, bit
unsigned char my_XPT_DCCQD (void);                                                      // f4
unsigned char my_XPT_DCCRL (void);                                                      // f5, read long addr
unsigned char my_XPT_DCCWL (unsigned int cv);                                           // f6, write long

unsigned char my_XPT_Term (void);

