//----------------------------------------------------------------
//
// OpenDCC
//
// Copyright (c) 2006 Kufer
//
// This source file is subject of the GNU general public license 2,
// that is available at the world-wide-web at
// http://www.gnu.org/licenses/gpl.txt
//
//-----------------------------------------------------------------
//
// file:      programmer.h
// author:    Wolfgang Kufer
// contact:   kufer@gmx.de
// history:   2006-04-13 V0.1 started
//            2006-12-04 V0.2 change to multitasking
//            2007-05-16 V0.3 added programmer_busy();
//
// 2do:       
//
//-----------------------------------------------------------------
//
// purpose:   lowcost central station for dcc
// content:   builds service mode

void init_programmer(void);
void run_programmer(void);
unsigned char programmer_busy(void);

typedef enum {VOID, READY, BUSY, REGMODE, CVMODE, SHORT} t_lenz_result;

void lprog_send_prog_result(t_lenz_result ergebnis);

void lprog_send_prog_result_again(void);

void lprog_read_register(unsigned char regnr);

void lprog_write_register(unsigned char regnr, unsigned char data);

// Note: lenz only allows for 256 cv-regs :-(

void lprog_read_cv(unsigned char lenz_cv);

void lprog_write_cv(unsigned char lenz_cv, unsigned char data);

void lprog_read_paged(unsigned char lenz_cv);

void lprog_write_paged(unsigned char lenz_cv, unsigned char data);
